set(YACLIB_ASAN 0)
set(YACLIB_UBSAN 0)
set(YACLIB_LSAN 0)
set(YACLIB_TSAN 0)
set(YACLIB_MEMSAN 0)

if (ASAN IN_LIST YACLIB_FLAGS)
  set(YACLIB_SAN 1)
  set(YACLIB_ASAN 1)
  include(yaclib_asan)
endif ()
if (UBSAN IN_LIST YACLIB_FLAGS)
  set(YACLIB_SAN 1)
  set(YACLIB_UBSAN 1)
  include(yaclib_ubsan)
endif ()
if (LSAN IN_LIST YACLIB_FLAGS)
  set(YACLIB_SAN 1)
  set(YACLIB_LSAN 1)
  include(yaclib_lsan)
endif ()
if (TSAN IN_LIST YACLIB_FLAGS)
  set(YACLIB_SAN 1)
  set(YACLIB_TSAN 1)
  include(yaclib_tsan)
endif ()
if (MEMSAN IN_LIST YACLIB_FLAGS)
  set(YACLIB_SAN 1)
  set(YACLIB_MEMSAN 1)
  include(yaclib_memsan)
endif ()
if (YACLIB_SAN AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC" AND NOT CMAKE_CXX_SIMULATE_ID STREQUAL "MSVC")
  # Nicer stack trace and recover
  list(APPEND YACLIB_COMPILE_OPTIONS -fno-omit-frame-pointer -fsanitize-recover=all)
endif ()

set(YACLIB_COVERAGE 0)
if (COVERAGE IN_LIST YACLIB_FLAGS)
  set(YACLIB_COVERAGE 1)
  list(APPEND YACLIB_LINK_OPTIONS --coverage)
  list(APPEND YACLIB_COMPILE_OPTIONS --coverage)
  list(APPEND YACLIB_DEFINITIONS NDEBUG)
endif ()

set(YACLIB_CORO 0)
if (CORO IN_LIST YACLIB_FLAGS)
  include(yaclib_coro)
endif ()

set(YACLIB_ATOMIC_EVENT 0)
if (ATOMIC_EVENT IN_LIST YACLIB_FLAGS)
  set(YACLIB_ATOMIC_EVENT 1)
endif ()

#TODO(myannyax) any ways this can be avoided?
if (YACLIB_FAULT)
  list(APPEND YACLIB_DEFINITIONS YACLIB_FAULT)
endif ()

if (ERROR IN_LIST YACLIB_LOG)
  list(APPEND YACLIB_DEFINITIONS YACLIB_LOG_ERROR)
endif ()
if (INFO IN_LIST YACLIB_LOG)
  list(APPEND YACLIB_DEFINITIONS YACLIB_LOG_INFO)
endif ()
if (DEBUG IN_LIST YACLIB_LOG)
  list(APPEND YACLIB_DEFINITIONS YACLIB_LOG_DEBUG)
endif ()

